#ifndef __HYDROFORTH__NUMBER_H__
#define __HYDROFORTH__NUMBER_H__

extern bool hydroforth__number__is_digit(char c);

extern unsigned char hydroforth__number__convert_hex_digit(HYDROFORTH__RESULT *const result, char c);

extern int hydroforth__number__parse_number_hex(HYDROFORTH__RESULT *const result, const char *const start, unsigned char len);

extern int hydroforth__number__parse_number(HYDROFORTH__RESULT *const result, const char *const start, unsigned char len);

extern unsigned char hydroforth__number__count_digits(int n);

typedef struct __HYDROFORTH__NUMBER
{
  bool (*is_digit)(char c);
  unsigned char (*convert_hex_digit)(HYDROFORTH__RESULT *const result, char c);
  int (*parse_number_hex)(HYDROFORTH__RESULT *const result, const char *const start, unsigned char len);
  int (*parse_number)(HYDROFORTH__RESULT *const result, const char *const start, unsigned char len);
  unsigned char (*count_digits)(int n);
} __HYDROFORTH__NUMBER;

#endif
